#include <bits/stdc++.h>
using namespace std;

int ferma[250][250];
int sm = INT_MAX;
int n,m;

void no(int x, int y, int ch) {
    if(x > 0 && (ferma[x-1][y] == -2 || (ferma[x-1][y] > 0 && ch+1 < ferma[x-1][y]))) {
        ferma[x-1][y] = ch+1;
        no(x-1,y,ch+1);
    }
    if(y > 0 && (ferma[x][y-1] == -2 || (ferma[x][y-1] > 0 && ch+1 < ferma[x][y-1]))) {
        ferma[x][y-1] = ch+1;
        no(x,y-1,ch+1);
    }
    if(x < n-1 && (ferma[x+1][y] == -2 || (ferma[x+1][y] > 0 && ch+1 < ferma[x+1][y]))) {
        ferma[x+1][y] = ch+1;
        no(x+1,y,ch+1);
    }
    if(y < m-1 && (ferma[x][y+1] == -2 || (ferma[x][y+1] > 0 && ch+1 < ferma[x][y+1]))) {
        ferma[x][y+1] = ch+1;
        no(x,y+1,ch+1);
    }
}

void path(int x, int y, int hod) {
    if(ferma[x][y] == -1) {
        sm = min(sm,hod);
        return;
    }
    if(x > 0 && (ferma[x-1][y] > hod+1 || ferma[x-1][y] == -1)) {
        path(x-1,y,hod+1);
    }
    if(y > 0 && (ferma[x][y-1] > hod+1 || ferma[x][y-1] == -1)) {
        path(x,y-1,hod+1);
    }
    if(x < n-1 && (ferma[x+1][y] > hod+1 || ferma[x+1][y] == -1)) {
        path(x+1,y,hod+1);
    }
    if(y < m-1 && (ferma[x][y+1] > hod+1 || ferma[x][y+1] == -1)) {
        path(x,y+1,hod+1);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    char a;
    int xd,yd;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            cin >> a;
            if(a == '.') {
                ferma[i][j] = -2;
            }
            else if(a == 'D') {
                ferma[i][j] = -1;
            }
            else if(a == 'X') {
                ferma[i][j] = -3;
            }
            else if(a == '*') {
                ferma[i][j] = 0;
            }
            else {
                xd = i;
                yd = j;
                ferma[i][j] = -2;
            }
        }
    }
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(ferma[i][j] == 0) {
                no(i,j,0);
            }
        }
    }
    path(xd,yd,0);
    if(sm < 100000) {
        cout << sm;
    }
    else {
        cout << "Impossible";
    }
    return 0;
}
