#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

char a[256][256];
pair<int,int> d[4]={{1,0},{-1,0},{0,1},{0,-1}};
bool visited[256][256];
int n,m;
pair<int,int> start,ffinal;
vector<pair<int,int>> paths;
vector<pair<int,int>> v;
int ans=1e9;

bool check(int i,int j,int index)
{
    for(pair<int,int> p:v){
        if(abs(i-p.first)+abs(j-p.second)==index+1){
            return false;
        }
    }
    return true;
}

void dfs(int x,int y)
{
    visited[x][y]=true;
    if(x==ffinal.first && y==ffinal.second){
        bool valid=true;
        for(int i=0;i<v.size()-1;i++){
            pair<int,int> p=v[i];
            if(!check(p.first,p.second,i)){
                valid=false;
                break;
            }
        }
        if(valid){
            int sz=paths.size();
            ans=min(ans,sz);
        }
        return;
    }
    for(int i=0;i<4;i++){
        int x2=x+d[i].first;
        int y2=y+d[i].second;
        if(x2>=1 && x2<=n && y2>=1 && y2<=m && !visited[x2][y2] && a[x2][y2]=='.'){
            paths.push_back({x2,y2});
            dfs(x2,y2);
            paths.pop_back();
            visited[x2][y2]=false;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            cin>>a[i][j];
            if(a[i][j]=='*'){
                v.push_back({i,j});
            }
            if(a[i][j]=='S'){
                start.first=i;
                start.second=j;
            }else if(a[i][j]=='D'){
                ffinal.first=i;
                ffinal.second=j;
                a[i][j]='.';
            }
        }
    }
    dfs(start.first,start.second);
    if(ans==1e9){
        cout<<"Impossible"<<endl;
    }else{
        cout<<ans<<endl;
    }
    return 0;
}
