#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long int ull;
typedef signed long long int sll;
struct Coord{
    ull r = 0;
    ull c = 0;
    Coord(){}
    Coord(ull ir, ull ic){
        r = ir;
        c = ic;
    }
    ull dist(Coord o){
        ull distr = abs(((sll)r) - ((sll)o.r));
        ull distc = abs(((sll)c) - ((sll)o.c));
        return distr + distc;
    }
};
int main(){
    ull rows, cols;
    cin >> rows >> cols;
    vector<string> mp;
    string wall;
    for(int i = 0; i < cols+2; i++){
        wall += 'X';
    }
    mp.push_back(wall);
    string cin_tmp;
    for(ull i = 0; i < rows; i++){
        cin >> cin_tmp;
        mp.push_back('X' + cin_tmp + 'X');
    }
    mp.push_back(wall);
    vector<Coord> rain;
    rows += 2;
    cols += 2;
    Coord pesho;
    Coord koshara;
    for(ull r = 0; r < rows; r++){
        for(ull c = 0; c < cols; c++){
            switch(mp[r][c]){
                case '*':rain.push_back(Coord(r,c));break;
                case 'S':pesho = Coord(r,c);break;
                case 'D':koshara = Coord(r,c);break;
            }
        }
    }
    vector<vector<ull>> rainMap;
    vector<vector<ull>> kosharaMap;
    ull recd;
    ull ds;
    recd = (rows*cols)+1;
    for(ull r = 0; r < rows; r++){
        vector<ull> tmpR;
        vector<ull> tmpK;
        for(ull c = 0; c < cols; c++){
            //rain
            if(mp[r][c] == 'X'){
                tmpR.push_back(0);
                tmpK.push_back(9999);
                continue;
            }
            recd = (rows*cols)+1;
            for(ull d = 0; d < rain.size(); d++){
                ds = Coord(r,c).dist(rain[d]);
                if(ds < recd){
                    recd = ds;
                }
            }
            tmpR.push_back(recd);
            //koshara
            tmpK.push_back(Coord(r,c).dist(koshara));
        }
        rainMap.push_back(tmpR);
        kosharaMap.push_back(tmpK);
    }
    if(false){
        for(ull r = 0; r < rows; r++){
                cout << mp[r] << '\n';
        }
        for(ull c = 0; c < cols; c++){
                cout << '#';
        }
        cout << '\n';
        for(ull r = 0; r < rows; r++){
            for(ull c = 0; c < cols; c++){
                cout << rainMap[r][c] << ' ';
            }
            cout << '\n';
        }
        for(ull c = 0; c < cols; c++){
                cout << '#';
        }
        cout << '\n';
        for(ull r = 0; r < rows; r++){
            for(ull c = 0; c < cols; c++){
                cout << kosharaMap[r][c] << ' ';
            }
            cout << '\n';
        }
    }
    //////////////////////////////////////////////////////////
    ull steps = 0;
    bool banup = false, bandown = false, banleft = false, banright = false;
    while((pesho.r != koshara.r) || (pesho.c != koshara.c)){
        //cout << "1 (" << pesho.r << ", " << pesho.c << "), stp: " << steps << '\n';
        banup = false, bandown = false, banleft = false, banright = false;
        if((rainMap[pesho.r+1][pesho.c] == steps) && (mp[pesho.r+1][pesho.c] != 'X')){bandown = true;}
        if((rainMap[pesho.r-1][pesho.c] == steps) && (mp[pesho.r+1][pesho.c] != 'X')){banup = true;}
        if((rainMap[pesho.r][pesho.c+1] == steps) && (mp[pesho.r+1][pesho.c] != 'X')){banleft = true;}
        if((rainMap[pesho.r][pesho.c-1] == steps) && (mp[pesho.r+1][pesho.c] != 'X')){banright = true;}

        //cout << "2\n";

        ull minKosh1 = min(kosharaMap[pesho.r+1][pesho.c], kosharaMap[pesho.r-1][pesho.c]);
        ull minKosh2 = min(kosharaMap[pesho.r][pesho.c+1], kosharaMap[pesho.r][pesho.c-1]);
        ull minKosh = min(minKosh1, minKosh2);

        //cout << "3\n";

        if(false){}
        else if((kosharaMap[pesho.r][pesho.c+1] == minKosh) && (mp[pesho.r][pesho.c+1] != 'X') && (!bandown)){pesho.c++;}
        else if((kosharaMap[pesho.r][pesho.c-1] == minKosh) && (mp[pesho.r][pesho.c-1] != 'X') && (!banup)){pesho.c--;}
        else if((kosharaMap[pesho.r+1][pesho.c] == minKosh) && (mp[pesho.r+1][pesho.c] != 'X') && (!banright)){pesho.r++;}
        else if((kosharaMap[pesho.r-1][pesho.c] == minKosh) && (mp[pesho.r-1][pesho.c] != 'X') && (!banleft)){pesho.r--;}
        else{cout << "Impossible";return 0;}

        steps++;
    }
    cout << steps;
    return 0;
}
